#version 330 core

layout(location = 0) in
vec3 vertexPositionIn;

uniform float Glow;
uniform int isRainbow;


uniform float time;
uniform vec3 origin;
uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;
uniform vec4 rgbaIn;

out vec4 rgba;
out float glow;
out vec3 vertexPosition;
out vec4 worldPos;
out vec4 camPos;


vec3 hue2rgb(float hue)
{
    hue = fract(hue); //only use fractional part of hue, making it loop
    float r = abs(hue * 6 - 3) - 1; //red
    float g = 2 - abs(hue * 6 - 2); //green
    float b = 2 - abs(hue * 6 - 4); //blue
    vec3 rgb = vec3(r, g, b); //combine components
    
    rgb.x = clamp(rgb.x, 0.0, 1.0); //clamp between 0 and 1
    rgb.y = clamp(rgb.y, 0.0, 1.0); //clamp between 0 and 1
    rgb.z = clamp(rgb.z, 0.0, 1.0); //clamp between 0 and 1
    return rgb;
}

void main(void)
{
    vec4 truePos = vec4(vertexPositionIn + origin, 1.0);
    vertexPosition = vertexPositionIn;

    worldPos = truePos;

    camPos = modelViewMatrix * worldPos;
    vec3 col = hue2rgb(sin(time / 2f));

    if(isRainbow == 1)
    {
        rgba = vec4(col, rgbaIn.w);
    }
    else
    {
        rgba = rgbaIn;
    }
    glow = Glow;
    vec4 result;
    result = projectionMatrix * camPos;
    
    result.w += .0025f;
    gl_Position = result;
}
